<?php defined("SYSPATH") or die("No direct script access.");
/**
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2009 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
class Admin_Photowidget_Controller extends Admin_Controller {
  public function index() {
    print $this->_get_view();
  }

  public function handler() {
    access::verify_csrf();

    $form = $this->_get_form();
    if ($form->validate()) {
      if (preg_match("/^#?([0-9a-f]{1,2}){3}$/i", $form->photowidget->photowidget_bgcolor->value) == 0) {
       $form->photowidget->photowidget_bgcolor->add_error("format", 1);
    	message::warning(t("Verify the proper format for the background color."));
        }
      if (preg_match("/^#?([0-9a-f]{1,2}){3}$/i", $form->recent->photowidget_bgcolor2->value) == 0) {
       $form->recent->photowidget_bgcolor2->add_error("format", 1);
    	message::warning(t("Verify the proper format for the background color of the recent block."));
        }
      if (preg_match("/^#?([0-9a-f]{1,2}){3}$/i", $form->popular->photowidget_bgcolor3->value) == 0) {
       $form->popular->photowidget_bgcolor3->add_error("format", 1);
    	message::warning(t("Verify the proper format for the background color of the popular block."));
        }
      if (preg_match("/^#?([0-9a-f]{1,2}){3}$/i", $form->popular_days->photowidget_bgcolor4->value) == 0) {
       $form->popular->photowidget_bgcolor4->add_error("format", 1);
    	message::warning(t("Verify the proper format for the background color of the popular in last X days block."));
        }
      else {
      module::set_var(
        "photowidget", "title", $form->photowidget->photowidget_title->value);
      module::set_var(
        "photowidget", "width", $form->photowidget->photowidget_width->value);
      module::set_var(
        "photowidget", "height", $form->photowidget->photowidget_height->value);
      module::set_var(
        "photowidget", "bgcolor", $form->photowidget->photowidget_bgcolor->value);
      module::set_var(
        "photowidget", "trans", $form->photowidget->photowidget_trans->value);
      module::set_var(
        "photowidget", "onphoto", $form->photowidget->photowidget_onphoto->value, true);
      module::set_var(
        "photowidget", "onalbum", $form->photowidget->photowidget_onalbum->value, true);

      module::set_var(
        "photowidget", "title2", $form->recent->photowidget_title2->value);
      module::set_var(
        "photowidget", "width2", $form->recent->photowidget_width2->value);
      module::set_var(
        "photowidget", "height2", $form->recent->photowidget_height2->value);
      module::set_var(
        "photowidget", "quantity2", $form->recent->photowidget_quantity2->value);
      module::set_var(
        "photowidget", "bgcolor2", $form->recent->photowidget_bgcolor2->value);
      module::set_var(
        "photowidget", "trans2", $form->recent->photowidget_trans2->value);
      module::set_var(
        "photowidget", "onphoto2", $form->recent->photowidget_onphoto2->value, true);
      module::set_var(
        "photowidget", "onalbum2", $form->recent->photowidget_onalbum2->value, true);
        
      module::set_var(
        "photowidget", "title3", $form->popular->photowidget_title3->value);
	  module::set_var(
        "photowidget", "width3", $form->popular->photowidget_width3->value);
	  module::set_var(
        "photowidget", "height3", $form->popular->photowidget_height3->value);
      module::set_var(
        "photowidget", "quantity3", $form->popular->photowidget_quantity3->value);
      module::set_var(
        "photowidget", "bgcolor3", $form->popular->photowidget_bgcolor3->value);
      module::set_var(
        "photowidget", "trans3", $form->popular->photowidget_trans3->value);
      module::set_var(
        "photowidget", "onphoto3", $form->popular->photowidget_onphoto3->value, true);
      module::set_var(
        "photowidget", "onalbum3", $form->popular->photowidget_onalbum3->value, true);
        
      module::set_var(
        "photowidget", "title4", $form->popular_days->photowidget_title4->value);
	  module::set_var(
        "photowidget", "width4", $form->popular_days->photowidget_width4->value);
	  module::set_var(
        "photowidget", "height4", $form->popular_days->photowidget_height4->value);
      module::set_var(
        "photowidget", "quantity4", $form->popular_days->photowidget_quantity4->value);
      module::set_var(
        "photowidget", "bgcolor4", $form->popular_days->photowidget_bgcolor4->value);
      module::set_var(
        "photowidget", "trans4", $form->popular_days->photowidget_trans4->value);
      module::set_var(
        "photowidget", "onphoto4", $form->popular_days->photowidget_onphoto4->value, true);
      module::set_var(
        "photowidget", "onalbum4", $form->popular_days->photowidget_onalbum4->value, true);
      module::set_var(
        "photowidget", "inlastxdays4", $form->popular_days->photowidget_inlastxdays4->value);
        
      message::success(t("Your settings have been saved."));
      url::redirect("admin/photowidget");
    }
	}
    print $this->_get_view($form);
  }

  private function _get_view($form=null) {
    $v = new Admin_View("admin.html");
    $v->content = new View("admin_photowidget.html");
    $v->content->form = empty($form) ? $this->_get_form() : $form;
    return $v;
  }

  private function _get_form() {
    for ($i = 5; $i <= 20; $i++) {
      $range[$i] = "$i";
	   }
    $form = new Forge("admin/photowidget/handler", "", "post", array("id" => "g-admin-form"));
    
    $group = $form->group("photowidget")->label(t("Photowidget block"));
    $group->input("photowidget_title")->label(t('Enter the title of the block.'))
		->value(module::get_var("photowidget", "title", "Items in this album"));
    $group->input("photowidget_width")->label(t('Enter the width the block. (pixels)'))
		->value(module::get_var("photowidget", "width", "200"))
		->rules("valid_numeric|length[2,3]");
    $group->input("photowidget_height")->label(t('Enter the height the block. (pixels)'))
		->value(module::get_var("photowidget", "height", "200"))
		->rules("valid_numeric|length[2,3]");
    $group->input("photowidget_bgcolor")->label(t('The background color value. Must be specified as xxxxxx'))
		->value(module::get_var("photowidget", "bgcolor", "ffffff"))
		->rules("length[6]")
		->error_messages("format", t("Wrong format"));
	$group->checkbox("photowidget_trans")->label(t("Transparent background"))
		->checked(module::get_var("photowidget", "trans"));
	$group->checkbox("photowidget_onalbum")->label(t("Show on album. (This block does not show on dynamic pages.)"))
		->checked(module::get_var("photowidget", "onalbum"));
	$group->checkbox("photowidget_onphoto")->label(t("Show on photo pages"))
		->checked(module::get_var("photowidget", "onphoto"));	
	  
    $group = $form->group("recent")->label(t("Recent photowidget block"));
	$group->input("photowidget_title2")->label(t('Enter the title of the recent block.'))
		->value(module::get_var("photowidget", "title2", "Recent items"));
    $group->input("photowidget_width2")->label(t('Enter the width the block. (pixels)'))
		->value(module::get_var("photowidget", "width2", "200"))
		->rules("valid_numeric|length[2,3]");
    $group->input("photowidget_height2")->label(t('Enter the height the block. (pixels)'))
		->value(module::get_var("photowidget", "height2", "200"))
		->rules("valid_numeric|length[2,3]");
    $group->dropdown("photowidget_quantity2")->label(t("Choose the quantity of items to show"))
      	->options($range)
      	->selected(module::get_var("photowidget", "quantity2", "20"));
    $group->input("photowidget_bgcolor2")->label(t('The background color value. Must be specified as xxxxxx'))
		->value(module::get_var("photowidget", "bgcolor2", "ffffff"))
		->rules("length[6]")
		->error_messages("format", t("Wrong format"));
	$group->checkbox("photowidget_trans2")->label(t("Transparent background"))
		->checked(module::get_var("photowidget", "trans2"));
	$group->checkbox("photowidget_onalbum2")->label(t("Show on album & collection pages"))
		->checked(module::get_var("photowidget", "onalbum2"));
	$group->checkbox("photowidget_onphoto2")->label(t("Show on photo pages"))
		->checked(module::get_var("photowidget", "onphoto2")); 
   
    $group = $form->group("popular")->label(t("Popular photowidget block"));
	$group->input("photowidget_title3")->label(t('Enter the title of the popular block.'))
		->value(module::get_var("photowidget", "title3", "Popular items"));
    $group->input("photowidget_width3")->label(t('Enter the width the block. (pixels)'))
		->value(module::get_var("photowidget", "width3", "200"))
		->rules("valid_numeric|length[2,3]");
    $group->input("photowidget_height3")->label(t('Enter the height the block. (pixels)'))
		->value(module::get_var("photowidget", "height3", "200"))
		->rules("valid_numeric|length[2,3]");
    $group->dropdown("photowidget_quantity3")->label(t("Choose the quantity of items to show"))
      	->options($range)
      	->selected(module::get_var("photowidget", "quantity3", "20"));
    $group->input("photowidget_bgcolor3")->label(t('The background color value. Must be specified as xxxxxx'))
		->value(module::get_var("photowidget", "bgcolor3", "ffffff"))
		->rules("length[6]")
		->error_messages("format", t("Wrong format"));
	$group->checkbox("photowidget_trans3")->label(t("Transparent background"))
		->checked(module::get_var("photowidget", "trans3"));
	$group->checkbox("photowidget_onalbum3")->label(t("Show on album & collection pages"))
		->checked(module::get_var("photowidget", "onalbum3"));
	$group->checkbox("photowidget_onphoto3")->label(t("Show on photo pages"))
		->checked(module::get_var("photowidget", "onphoto3"));
    
    $group = $form->group("popular_days")->label(t("Popular in last X days photowidget block"));
      $lastxdays = module::get_var("photowidget", "inlastxdays4", "30");
	$group->input("photowidget_title4")->label(t('Enter the title of the popular block.'))
		->value(module::get_var("photowidget", "title4", "Popular items in last $lastxdays days"));
    $group->input("photowidget_width4")->label(t('Enter the width the block. (pixels)'))
		->value(module::get_var("photowidget", "width4", "200"))
		->rules("valid_numeric|length[2,3]");
    $group->input("photowidget_height4")->label(t('Enter the height the block. (pixels)'))
		->value(module::get_var("photowidget", "height4", "200"))
		->rules("valid_numeric|length[2,4]");
    $group->dropdown("photowidget_quantity4")->label(t("Choose the quantity of items to show"))
		->options($range)
		->selected(module::get_var("photowidget", "quantity4", "20"));
    $group->input("photowidget_inlastxdays4")->label(t('Enter number of days to look back'))
		->value(module::get_var("photowidget","inlastxdays4","30"))
		->rules("valid_numeric");
    $group->input("photowidget_bgcolor4")->label(t('The background color value. Must be specified as xxxxxx'))
		->value(module::get_var("photowidget", "bgcolor4", "ffffff"))
		->rules("length[6]")
		->error_messages("format", t("Wrong format"));
	$group->checkbox("photowidget_trans4")->label(t("Transparent background"))
		->checked(module::get_var("photowidget", "trans4"));
	$group->checkbox("photowidget_onalbum4")->label(t("Show on album & collection pages"))
		->checked(module::get_var("photowidget", "onalbum4"));
	$group->checkbox("photowidget_onphoto4")->label(t("Show on photo pages"))
		->checked(module::get_var("photowidget", "onphoto4"));
    
	$form->submit("submit")->value(t("Save"));
    return $form;
  }
}
