<?php defined("SYSPATH") or die("No direct script access.");
/**
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2009 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
class Photowidget_Controller extends Controller {
  public function xml($id) {
	$item = ORM::factory("item", $id);
	header("Content-type: text/xml");
    print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
	print "<images>\n";
    foreach ($item->viewable()->children() as $child) {
      print "<image href=\"" . $child->abs_url() . "\">{$child->thumb_url(true)}</image>\n";
    }
    print "</images>\n";
  }
  public function recent_xml() {
    $quantity = module::get_var("photowidget", "quantity2");
      $photos = ORM::factory("item")->viewable()
        ->where("type", "!=", "album")->order_by("created", "DESC")->find_all($quantity);
	header("Content-type: text/xml");
    print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
	print "<images>\n";
    foreach ($photos as $photo) {
      print "<image href=\"" . $photo->abs_url() . "\">{$photo->thumb_url(true)}</image>\n";
    }
    print "</images>\n";
  }
  public function popular_xml() {
    $quantity = module::get_var("photowidget", "quantity3");
      $photos = ORM::factory("item")->viewable()
        ->where("type", "!=", "album")->order_by("view_count", "DESC")->find_all($quantity);
	header("Content-type: text/xml");
    print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
	print "<images>\n";
    foreach ($photos as $photo) {
      print "<image href=\"" . $photo->abs_url() . "\">{$photo->thumb_url(true)}</image>\n";
    }
    print "</images>\n";
  }
  public function popular_lastxdays_xml() {
    $quantity = module::get_var("photowidget", "quantity4");
    $daysback = time() - (module::get_var("photowidget", "inlastxdays4") * 60 * 60 * 24);
      $photos = ORM::factory("item")->viewable()
        ->where("type", "!=", "album")->where("created", ">", $daysback, "DESC")->order_by("view_count", "DESC")->find_all($quantity);
	header("Content-type: text/xml");
    print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
	print "<images>\n";
    foreach ($photos as $photo) {
      print "<image href=\"" . $photo->abs_url() . "\">{$photo->thumb_url(true)}</image>\n";
    }
    print "</images>\n";
  }
}
