<?php defined("SYSPATH") or die("No direct script access.");
/**
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2009 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
class photowidget_block_Core {
  static function get_site_list() {
    return array(
		"photowidget" => t("Photowidget"),
		"photowidget_recent" => t("Recent items Photowidget"),
		"photowidget_popular" => t("Popular items Photowidget"),
		"photowidget_popular_lastxdays" => t("Popular items in last X days Photowidget"));
	}

  static function get($block_id, $theme) {
    $block = "";
    switch ($block_id) {
    case "photowidget":
    if ($theme->item() != null) {
      if (module::get_var("photowidget", "onalbum") && $theme->page_type == "collection" ||
	    module::get_var("photowidget", "onphoto") && $theme->page_type == "item") {
        $block = new Block();
        $block->css_id = "g-metadata";
        $block->title = module::get_var("photowidget", "title", "Items in this album");
	$block->content = new View("photowidget.html");
      }
    }
      break;
    case "photowidget_recent":
      if (module::get_var("photowidget", "onalbum2") && $theme->page_type == "collection" || 
	    module::get_var("photowidget", "onphoto2") && $theme->page_type == "item") {
        $block = new Block();
        $block->css_id = "g-metadata";
        $block->title = module::get_var("photowidget", "title2", "Recent items");
	$block->content = new View("photowidget_recent.html");
      }
      break;
    case "photowidget_popular":
      if (module::get_var("photowidget", "onalbum3") && $theme->page_type == "collection" ||
	    module::get_var("photowidget", "onphoto3") && $theme->page_type == "item") {
        $block = new Block();
        $block->css_id = "g-metadata";
        $block->title = module::get_var("photowidget", "title3", "Popular items");
	$block->content = new View("photowidget_popular.html");
      }
      break;
    case "photowidget_popular_lastxdays":
      if (module::get_var("photowidget", "onalbum4") && $theme->page_type == "collection" ||
	    module::get_var("photowidget", "onphoto4") && $theme->page_type == "item") {
	$lastxdays4 = module::get_var("photowidget","inlastxdays4");
        $block = new Block();
        $block->css_id = "g-metadata";
        $block->title = module::get_var("photowidget", "title4", "Popular items in the last $lastxdays4 days");
	$block->content = new View("photowidget_popular_lastxdays.html");
      }
      break;
    }
    return $block;
  }
}
